function [A0,edges]=CheetahReRob(A,k)
%{
 Goal : Melting Graph

 Input:
   A:  Graph
   k:  Number of edges 

 Output:
   A0: New graph after melting
   eiges: Melted edges 

 Reference: 
    Li, Liangyue, et al. "Cheetah: 
    fast graph kernel tracking on dynamic 
    graphs." SDM, 2015.
%}
A0=A;
n=size(A0,2);
t=2;
[V0,D0]=eigs(A0,t);
%%Vec
D000=diag(D0);
[seD,indD] = sort(D000,'descend');
D0=diag(seD);
robSD0=0;
for tt=1:t
   robSD0=robSD0+exp(D0(tt,tt)); %%sum of exp(D0)
   V1(:,tt)=V0(:,indD(tt));
end
%%score Rob
roblum=log(robSD0/t);%%Robustness
roblum0=roblum;
aaa=0;
ccc=0;

for kn=1:k
    x=0;
 for i=1:n
     for j=i:n
        
             if (A0(i,j)==1)

                   x=x+1;         
  
% ---------------------udEigen------------------------------
                  [Vt,Dt]=udEigen(V1,D0,i,j,n,t);
% ---------------------udEigen------------------------------                  
                  
                  Dt000=diag(Dt);
                  [seDt,indDt] = sort(Dt000,'descend');
                  Dt=diag(seDt);
                  SDt=0;
                  for tt=1:t
                   SDt=SDt+exp(Dt(tt,tt));  
                  end
                    lumt=log(SDt/t); 
                  Dd=abs(lumt-roblum);
                  lum2(x)=Dd; %% score
                  Ad=zeros(n,n);
                  ix(x)=i;
                  jx(x)=j;  %% edges
             end         
     end
  end
[m,ind]=max(lum2);  
lum2=0;
aaa=aaa+1;
edges(aaa,1)=ix(ind);  %% selected edges 
edges(aaa,2)=jx(ind);
A0(ix(ind),jx(ind))=0;  
A0(jx(ind),ix(ind))=0;
[V0,D0]=eigs(A0,t);
D000=diag(D0);
[seD,indD] = sort(D000,'descend');
D0=diag(seD);
robSD0=0;
for tt=1:t
 robSD0=robSD0+exp(D0(tt,tt)); %%sum of exp(D0) 
 V1(:,tt)=V0(:,indD(tt));
end
roblum=log(robSD0/t);
end
end