function [newA, edges]=GCO_Melt_Edges(A,k,Method)
%{
 Goal : Melting Graph Edges

 Input:
   A:  Graph
   k:  Number of edges 
   Method: Method of selecting edges

 Output:
   newA: New graph after melting
   eiges: Melted edges 

%}


if Method=='NETMELTR'
    [newA, edges]=NetmeltRe(A,k);
elseif Method=='NETMELTO'
    [newA, edges]=Netmelt(A,k);
elseif Method=='MBOVE10S'
    [newA, edges]=MiobiVec10S(A,k);
elseif Method=='MBOVEC10'
    [newA, edges]=MiobiVec10(A,k);
elseif Method=='MBOVECTO'
    [newA, edges]=MiobiVec(A,k);
elseif Method=='MBOTRIAN'
    [newA, edges]=MiobiTri(A,k);
elseif Method=='MBOROBUS'
    [newA, edges]=MiobiRob(A,k);
elseif Method=='MBOFIRST'
    [newA, edges]=MiobiFirst(A,k);
elseif Method=='MBRVE10S'
    [newA, edges]=MiobiReVec10S(A,k);
elseif Method=='MBRVEC10'
    [newA, edges]=MiobiReVec10(A,k);
elseif Method=='MBRVECTO'
    [newA, edges]=MiobiReVec(A,k);
elseif Method=='MBRTRIAN'
    [newA, edges]=MiobiReTri(A,k);
elseif Method=='MBRROBUS'
    [newA, edges]=MiobiReRob(A,k);
elseif Method=='MBRFIRST'
    [newA, edges]=MiobiReFirst(A,k);
elseif Method=='CTOVE10S'
    [newA, edges]=CheetahVec10S(A,k);
elseif Method=='CTOVEC10'
    [newA, edges]=CheetahVec10(A,k);
elseif Method=='CTOVECTO'
    [newA, edges]=CheetahVec(A,k);
elseif Method=='CTOTRIAN'
    [newA, edges]=CheetahTri(A,k);
elseif Method=='CTOROBUS'
    [newA, edges]=CheetahRob(A,k);
elseif Method=='CTOFIRST'
    [newA, edges]=CheetahFirst(A,k);
elseif Method=='CTRVE10S'
    [newA, edges]=CheetahReVec10S(A,k);
elseif Method=='CTRVEC10'
    [newA, edges]=CheetahReVec10(A,k);
elseif Method=='CTRVECTO'
    [newA, edges]=CheetahReVec(A,k);
elseif Method=='CTRTRIAN'
    [newA, edges]=CheetahReTri(A,k);
elseif Method=='CTRROBUS'
    [newA, edges]=CheetahReRob(A,k);
elseif Method=='CTRFIRST'
    [newA, edges]=CheetahReFirst(A,k);
end
    
end