function [A0,edges]=MiobiReTri(A,k)
%{
 Goal : Melting Graph

 Input:
   A:  Graph
   k:  Number of edges 

 Output:
   A0: New graph after melting
   eiges: Melted edges 

 Reference: 
    Chan, Hau, Leman Akoglu, and Hanghang Tong. 
   "Make It or Break It: Manipulating Robustness 
   in Large Networks." SDM. 2014.
%}
A0=A;
n=size(A0,2);
t=2;
[V0,D0]=eigs(A0,t);
D000=diag(D0);
[seD,indD] = sort(D000,'descend');
D0=diag(seD);
triSD0=0;
for tt=1:t
   triSD0=triSD0+D0(tt,tt)^3; %%sum of (D0)^3
   V1(:,tt)=V0(:,indD(tt));
end
%%tri
trilum=triSD0/6;
trilum0=trilum;
aaa=0;
ccc=0;




for kn=1:k
    x=0;
 for i=1:n
     for j=i:n
        
             if (A0(i,j)==1)
                   A1=A0;   %eigs
                   x=x+1;
                Ad=zeros(n,n);  %% n x n zero metrix
                Ad(i,j)=-1;
                Ad(j,i)=-1; %% delta A for each edge
%---------------------miobi------------------------------
                  [Vt,Dt]=miobiEigen(V1,D0,Ad,t);
%---------------------miobi------------------------------
%                   Dt=abs(Dt);
                 
                  Dt000=diag(Dt);
                  [seDt,indDt] = sort(Dt000,'descend');
                  Dt=diag(seDt);
                  SDt=0;
                  for tt=1:t
                   SDt=SDt+Dt(tt,tt)^3;
                  end
                     lumt=SDt/6;
 
                  Dd=abs(lumt-trilum);
                  lum2(x)=Dd; %% score
                  Ad=zeros(n,n);
                  ix(x)=i;
                  jx(x)=j;  %% edges
                 
             end
         
     end
  end
[m,ind]=max(lum2); 
lum2=0;
aaa=aaa+1;
edges(aaa,1)=ix(ind);  %% selected edges 
edges(aaa,2)=jx(ind);

A0(ix(ind),jx(ind))=0;  
A0(jx(ind),ix(ind))=0;

[V0,D0]=eigs(A0,t);

    
D000=diag(D0);
[seD,indD] = sort(D000,'descend');
D0=diag(seD);
triSD0=0;

for tt=1:t
 triSD0=triSD0+D0(tt,tt)^3; %%sum of exp(D0)
 
 V1(:,tt)=V0(:,indD(tt));
end
trilum=triSD0/6;

end
end