function [A0,edges]=MiobiRob (A,k)
%{
 Goal : Melting Graph

 Input:
   A:  Graph
   k:  Number of edges 

 Output:
   A0: New graph after melting
   eiges: Melted edges 

 Reference: 
    Chan, Hau, Leman Akoglu, and Hanghang Tong. 
   "Make It or Break It: Manipulating Robustness 
   in Large Networks." SDM. 2014.
%}
A0=A;

n=size(A0,2);
t=2;
[V0,D0]=eigs(A0,t);



D000=diag(D0);
[seD,indD] = sort(D000,'descend');
D0=diag(seD);
robSD0=0;

for tt=1:t
   robSD0=robSD0+exp(D0(tt,tt)); %%sum of exp(D0)
   V1(:,tt)=V0(:,indD(tt));
end
%%score Rob
roblum=log(robSD0/t);%%Robustness
roblum0=roblum;

aaa=0;
ccc=0;





    x=0;
 for i=1:n
     for j=i:n
        
             if (A0(i,j)==1)
                   A1=A0;   %eigs
                   x=x+1;
                Ad=zeros(n,n);  %% n x n zero metrix
                Ad(i,j)=-1;
                Ad(j,i)=-1; %% delta A for each edge
%---------------------miobi------------------------------
                  [Vt,Dt]=miobiEigen(V1,D0,Ad,t);
%---------------------miobi------------------------------
%                   Dt=abs(Dt);
                 
                  Dt000=diag(Dt);
                  [seDt,indDt] = sort(Dt000,'descend');
                  Dt=diag(seDt);
                  SDt=0;
                  for tt=1:t
                   SDt=SDt+exp(Dt(tt,tt));
                    
                  end
                    lumt=log(SDt/t);
 
                  Dd=abs(lumt-roblum);
                  lum2(x)=Dd; %% score
                  Ad=zeros(n,n);
                  ix(x)=i;
                  jx(x)=j;  %% edges
                 
             end
         
     end
  end
[m,ind]=sort(lum2,'descend');

for kn=1:k
A0(ix(ind(kn)),jx(ind(kn)))=0;  
A0(jx(ind(kn)),ix(ind(kn)))=0;
edges(kn,2)=ix(ind(kn));
edges(kn,1)=jx(ind(kn));

end

end
