function [newA,edges]=Netmelt(A,k)
%{
 Goal : Melting Graph

 Input:
   A:  Graph
   k:  Number of edges 

 Output:
   newA: New graph after melting
   eiges: Melted edges 

 Reference: 
   Tong, Hanghang, et al. "Gelling,
   and melting, large graphs by edge 
   manipulation." ACM, 2012.
%}
A0=A;
n=size(A0,2);

A0T= A0';
t=2;
[V0,D0]=eigs(A0,t); %%  D is eigenvalue and V is right eigenvectors
vecV=abs(V0(:,1));
[veclum,indV]=max(vecV);
veclum0=veclum;
indV0=indV;

[V0T,D0T]=eigs(A0T,t);%% V is left eigenvectors 

V0=abs(V0);
D0=abs(D0);
V0T=abs(V0T);
D000=diag(D0);
[seD,indD] = sort(D000,'descend');
D0=diag(seD);

for tt=1:t
   V1(:,tt)=V0(:,indD(tt));
end

x=0;
for i=1:n
     for j=1:n
         if i>j              %% go through upper-triangle
             if (A0(i,j)==1)
                 x=x+1;
                  lum1(x)=V0(i, 1) * V0T(j, 1);
                  ix(x)=i;
                 jx(x)=j;  %% edges
                 
             end
         end
     end
end

[se,index] = sort(lum1,'descend');
newA=A0;

for kn=1:k
 newA(ix(index(kn)),jx(index(kn)))=0; 
 newA(jx(index(kn)),ix(index(kn)))=0;
 edges(kn,2)=ix(index(kn));
 edges(kn,1)=jx(index(kn));
end 
end




