function [Q,R] = myQR(U, X,i,j)
% QR-decomposition like algorithm

    [m, l] = size(U);
    t = size(X,2);
    
    R = zeros(t);

    Q(:,1)=X(:,1) - (1/sqrt(2))*U*(U(i,:)-U(j,:))';
    Q(:,2)=X(:,2) + (1/sqrt(2))*U*(U(i,:)+U(j,:))';
    for jj = 1:t
        R(jj,jj) = norm(Q(:,jj));
        Q(:,jj) = Q(:,jj)/R(jj,jj);
        for k = jj+1:t
            R(jj,k) = Q(:,jj)'*Q(:,k);
            Q(:,k) = Q(:,k) - R(jj,k)*Q(:,jj);
        end
    end
    Q = [U,Q];
    I = eye(l);
    A = U'*X;
    B = zeros(t,l);
    R = [I,A;B,R];
end